'-------------------------------------------------------------------------------
' Description:
'
' SE-MINI-STAR
'
' Melody & LED Display Kit
'
'
' Written by Junghoon Kim 17-JULY-2008
' Compiled by BASCOM AVR Demo
' http://www.MCSELEC.COM
'
' SAMPLE Electronics co.
' C-18 P1-fl. Main-bd ET-Land 16-9 Hangangno-3ga Yongsan-gu
' Seoul 190-879 South KOREA
' Phone: +82-2-701-8051
' Fax:   +82-2-701-8058
' Mail : sample@korea.com
' Web : HPP://WWW.SAMPLE.CO.KR
'
'-------------------------------------------------------------------------------
$regfile = "Attiny2313.dat"
'-------------------------------------------------------------------------------
'
'                         <<    ڵ ǥ   >>
'
' ||A| | |C||D| | |F||G||A| | |C||D| | |F||G||A| | |C||D| | |F||G||A| | |C||D| |
' ||2| | |3||3| | |3||3||3| | |4||4| | |4||4||4| | |5||5| | |5||5||5| | |6||6| |
' ||#| | |#||#| | |#||#||#| | |#||#| | |#||#||#| | |#||#| | |#||#||#| | |#||#| |
'|  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
'|A2|B2|C3|D3|E3|F3|G3|A3|B3|C4|D4|E4|F4|G4|A4|B4|C5|D5|E5|F5|G5|A5|B5|C6|D6|E6|
'|  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |
'|||||||||||||||||||||||||||
'+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
'
'                                                            ' Freq.Hz| Cycle mS
'-------------------------------------------------------------------------------
Const B2 = 255                                              ' 123.471| 8.0990
'-------------------------------------------------------------------------------
Const C3 = 245                                              ' 130.818| 7.6445
Const C3s = 230                                             ' 138.591| 7.2154
Const D3 = 217                                              ' 146.832| 6.8105
Const D3s = 205                                             ' 155.561| 6.0217
Const E3 = 193                                              ' 164.814| 6.0217
Const F3 = 185                                              ' 174.614| 5.7269
Const F3s = 172                                             ' 184.997| 5.4054
Const G3 = 162                                              ' 195.998| 5.1020
Const G3s = 153                                             ' 207.652| 4.8157
Const A3 = 144                                              ' 220.000| 4.5454
Const A3s = 136                                             ' 233.082| 4.3321
Const B3 = 128                                              ' 246.942| 4.0495
'-------------------------------------------------------------------------------
Const C4 = 120                                              ' 261.626| 3.8222
Const C4s = 114                                             ' 277.183| 3.6077
Const D4 = 107                                              ' 293.665| 3.4052
Const D4s = 101                                             ' 311.122| 3.0108
Const E4 = 95                                               ' 329.612| 2.8634
Const F4 = 90                                               ' 349.288| 2.7027
Const F4s = 84                                              ' 369.994| 2.7027
Const G4 = 79                                               ' 391.995| 2.5510
Const G4s = 75                                              ' 415.305| 2.4078
Const A4 = 70                                               ' 440.000| 2.2727
Const A4s = 66                                              ' 466.164| 2.1660
Const B4 = 62                                               ' 493.883| 2.0247
'-------------------------------------------------------------------------------
Const C5 = 59                                               ' 523.251| 1.9111
Const C5s = 55                                              ' 554.365| 1.8038
Const D5 = 52                                               ' 587.330| 1.7026
Const D5s = 49                                              ' 622.254| 1.6070
Const E5 = 46                                               ' 659.255| 1.5054
Const F5 = 43                                               ' 698.456| 1.4317
Const F5s = 41                                              ' 739.989| 1.3513
Const G5 = 38                                               ' 783.991| 1.2755
Const G5s = 36                                              ' 830.609| 1.2039
Const A5 = 34                                               ' 880.000| 1.1363
Const A5s = 32                                              ' 923.328| 1.0830
Const B5 = 30                                               ' 987.767| 1.0123
'-------------------------------------------------------------------------------
Const C6 = 28                                               '1046.502| 0.9555
Const C6s = 26                                              '1108.731| 0.9019
Const D6 = 25                                               '1174.659| 0.8513
Const D6s = 23                                              '1244.508| 0.8035
Const E6 = 21                                               '1328.510| 0.7527
'-------------------------------------------------------------------------------
'
$crystal = 1000000
'
Dim I As Byte
Dim L As Byte
Dim K As Byte
Dim X As Byte
Dim S As Byte
Dim J As Word
Dim M As Word
Dim P As Word
Dim Noteon As Word
'
Config Portd = Output
Config Portb = Output
Config Porta = Output
'
Portb = &HFF : Portd = &HFF
'
S = 0
'-------------------------------------------------------------------------------
'
Main:
'
'----------------  1 -------------------------------------------------------
'
Noteon = 100
K = G4 : Gosub Melody
K = G4 : Gosub Melody
K = D5 : Gosub Melody
K = D5 : Gosub Melody
K = E5 : Gosub Melody
K = E5 : Gosub Melody
Noteon = 200
K = D5 : Gosub Melody
Noteon = 100
K = C5 : Gosub Melody
K = C5 : Gosub Melody
K = B4 : Gosub Melody
K = B4 : Gosub Melody
K = A4 : Gosub Melody
K = A4 : Gosub Melody
Noteon = 200
K = G4 : Gosub Melody
Noteon = 100
K = D5 : Gosub Melody
K = D5 : Gosub Melody
K = C5 : Gosub Melody
K = C5 : Gosub Melody
K = B4 : Gosub Melody
K = B4 : Gosub Melody
Noteon = 200
K = A4 : Gosub Melody
Noteon = 100
K = D5 : Gosub Melody
K = D5 : Gosub Melody
K = C5 : Gosub Melody
K = C5 : Gosub Melody
K = B4 : Gosub Melody
K = B4 : Gosub Melody
Noteon = 200
K = A4 : Gosub Melody
Noteon = 100
K = G4 : Gosub Melody
K = G4 : Gosub Melody
K = D5 : Gosub Melody
K = D5 : Gosub Melody
K = E5 : Gosub Melody
K = E5 : Gosub Melody
Noteon = 200
K = D5 : Gosub Melody
Noteon = 100
K = C5 : Gosub Melody
K = C5 : Gosub Melody
K = B4 : Gosub Melody
K = B4 : Gosub Melody
K = A4 : Gosub Melody
K = A4 : Gosub Melody
Noteon = 200
K = G4 : Gosub Melody
'
'----------------  2 -------------------------------------------------------
Noteon = 100
K = G4 : Gosub Melody
K = A4 : Gosub Melody
K = B4 : Gosub Melody
K = G4 : Gosub Melody
K = G4 : Gosub Melody
K = A4 : Gosub Melody
K = B4 : Gosub Melody
K = G4 : Gosub Melody
K = B4 : Gosub Melody
K = C5 : Gosub Melody
Noteon = 200
K = D5 : Gosub Melody
Noteon = 100
K = B4 : Gosub Melody
K = C5 : Gosub Melody
Noteon = 200
K = D5 : Gosub Melody
Noteon = 50
K = D5 : Gosub Melody
K = E5 : Gosub Melody
K = D5 : Gosub Melody
K = C5 : Gosub Melody
Noteon = 100
K = B4 : Gosub Melody
K = G4 : Gosub Melody
Noteon = 50
K = D5 : Gosub Melody
K = E5 : Gosub Melody
K = D5 : Gosub Melody
K = C5 : Gosub Melody
Noteon = 100
K = B4 : Gosub Melody
K = G4 : Gosub Melody
Noteon = 100
K = G4 : Gosub Melody
K = D3 : Gosub Melody
Noteon = 200
K = G4 : Gosub Melody
Noteon = 100
K = G4 : Gosub Melody
K = D3 : Gosub Melody
Noteon = 200
K = G4 : Gosub Melody
'
Waitms 200
'
Goto Main
'
End
'-------------------------------------------------------------------------------
Melody:                                                     ' ε  ߻

L = K
P = 60 * Noteon
M = P / L

For J = 0 To M
  For I = 0 To L
  Next I
Porta = &H002
  For I = 0 To L
  Next I
Porta = &H001
Next J

S = S Mod 64
If S = 0 Then
  Restore Ledpatt
End If

Read X : Portb = X : Read X : Portd = X
S = S + 1

Waitms 10

Return
'
'-------------------------------------------------------------------------------
Ledpatt:
'      PORT B       PORT D
'       76543210    76543210
Data &B00000000 , &B00000000                                ' 0
Data &B11111111 , &B11111111                                ' 1
Data &B00000000 , &B00000000                                ' 2
Data &B11111111 , &B11111111                                ' 3
Data &B11110111 , &B11111111                                ' 4
Data &B11110011 , &B11111111                                ' 5
Data &B11110001 , &B11111111                                ' 6
Data &B11110000 , &B10111111                                ' 7

Data &B11110000 , &B10011111                                ' 8
Data &B11110000 , &B10001111                                ' 9
Data &B11110000 , &B10000111                                ' 10
Data &B11110000 , &B10000011                                ' 11
Data &B11110000 , &B10000001                                ' 12
Data &B11110000 , &B10000000                                ' 13
Data &B01110000 , &B10000000                                ' 14
Data &B00110000 , &B10000000                                ' 15

Data &B00010000 , &B10000000                                ' 16
Data &B00000000 , &B10000000                                ' 17
Data &B00000000 , &B00000000                                ' 18
Data &B11111111 , &B11111111                                ' 19
Data &B00000000 , &B00000000                                ' 20
Data &B11111111 , &B11111111                                ' 21
Data &B00000000 , &B00000000                                ' 22
Data &B11111111 , &B11111111                                ' 23

Data &B00000000 , &B00000000                                ' 24
Data &B11111111 , &B11111111                                ' 25
Data &B00000000 , &B00000000                                ' 26
Data &B11111111 , &B11111111                                ' 27
Data &B11110011 , &B11111111                                ' 28
Data &B10010011 , &B11111111                                ' 29
Data &B10010011 , &B11111100                                ' 30
Data &B10010011 , &B11100100                                ' 31

Data &B10010010 , &B10100100                                ' 32
Data &B00000000 , &B10000000                                ' 33
Data &B11111111 , &B11111111                                ' 34
Data &B00000000 , &B00000000                                ' 35
Data &B11111111 , &B11111111                                ' 36
Data &B10110110 , &B11101101                                ' 37
Data &B10010010 , &B10100100                                ' 38
Data &B00000000 , &B10000000                                ' 39

Data &B11111111 , &B11111111                                ' 40
Data &B00000000 , &B00000000                                ' 41
Data &B11111111 , &B11111111                                ' 42
Data &B00000000 , &B00000000                                ' 43
Data &B11111111 , &B11111111                                ' 44
Data &B11100011 , &B11111111                                ' 45
Data &B11111100 , &B10111111                                ' 46
Data &B11111111 , &B11000111                                ' 47

Data &B11111111 , &B11111000                                ' 48
Data &B00011111 , &B11111111                                ' 49
Data &B11111111 , &B11111111                                ' 50
Data &B00000000 , &B00000000                                ' 51
Data &B11111111 , &B11111111                                ' 52
Data &B00000000 , &B00000000                                ' 53
Data &B11111111 , &B11111111                                ' 54
Data &B00000000 , &B10111111                                ' 55

Data &B11111111 , &B11000000                                ' 56
Data &B00000000 , &B10111111                                ' 57
Data &B11111111 , &B11000000                                ' 58
Data &B00000000 , &B10111111                                ' 59
Data &B11111111 , &B11000000                                ' 60
Data &B11111111 , &B11111111                                ' 61
Data &B00000000 , &B00000000                                ' 62
Data &B11111111 , &B11111111                                ' 63
'
'===============================================================================
'   END OF FILE
'===============================================================================


